<h1>Task 2</h1>

[Worksheet 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1) | [Task 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%201) | [Task 3](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%203) | [Task 4](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%204)

The goal of task 2 was to extend the "my_string" class to include automatic reference counting. This is an increment on the functionality of task 1 and requires adding or changing a few aspects of the header, "my_string.hpp" file.
<br/>
<h3>Step 1 - New Variable</h3>
The first step is an addition, an integer variable which keeps track of the number of objects sharing the same data.<br/>
![ref count](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task2_ref_count.png "ref count")<br/>
<h3>Step 2 - Modify constructor</h3>
The second step is to modify the Constructor to initialise the reference counter("ref_count") to 1 whenever a new object is created.<br/>
![Modified Constructor](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task2_mod_const.png "Modified Constructor")<br/>
<h3>Step 3 - Modify copy constructor</h3>
Next the copy constructor needs to be modified to copy the data pointer and increment the reference counter. <br/>
![Modified copy constructor](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task2_mod_copy_const.png "Modified copy constructor")<br/>
<h3>Step 4 - Modify assignment operator<h3/>
The assignment operator needs to be changed in several ways, primarily in making sure that multiple objects share the same memory when viable and that memory freed only when the reference counter reaches 0.<br/>
![Modified assignment operator](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task2_mod_operator.png "Modified assignment operator")<br/>
<h3>Step 5 - Modify print method</h3>
This step alters the print function to display the current reference count.<br/>
![Modified print](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task2_mod_print.png "Modified Print")
<h4>Step 6 - Testing</h3>
Testing is again relatively simple. The same code from task 1 works and gives the result outlined in the worksheet.<br/>
![Testing](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task2_testing.png "testing")<br/><br/><br/>

Current page - task 2<br/>
[Worksheet 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1) | [Task 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%201) | [Task 3](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%203) | [Task 4](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%204)