// Rewritten from task 3 to be assigned to the template class
#ifndef MY_STRING_HPP
#define MY_STRING_HPP

#include "temp_ref.hpp"
#include <cstring>
#include <iostream>

class my_string {
private:
    char* data;

public:
    my_string(const char* str){
        data = new char[std::strlen(str)+1];
        std::strcpy(data, str);
    }

    ~my_string() {
        delete[] data;
    }

    char getChar( int i, char c){
        if (i < 0 || i >= std::strlen(data)) throw std::out_of_range("Out of range.");
        return data[i];
    }

    void setChar(int i, char c){
        if (i < 0 || i >= std::strlen(data)) throw std::out_of_range("Out of range.");
        data[i] = c;
    }

    void print() const{
        std::cout << data << std::endl;
    }
};

#endif